
Object subclass: #List
  instanceVariableNames: 
    'root size last pos '
  classVariableNames: ''
  poolDictionaries: ''    !


!List class methods !

init
    ^self new init.! !



!List methods !
 
getNext

|tmp|

tmp:=pos data.
(pos notNil) ifTrue:
    [pos:= pos next].
^tmp.!
 
init
    "Private"
    size:=0.!
  
insert: anObject

    self insertNode:(Node data: anObject).!
 
insertNode: aNode
|tmp|
tmp:=aNode.
[tmp next notNil] whileTrue:
    [size:=size+1.
     tmp:=tmp next.].
size:=size+1.
(last isNil)
    ifTrue:[pos:=root:=aNode]
    ifFalse:[last next: aNode].
    last:=tmp.!

printOn: aStream
|tmp|

tmp:=root.
aStream nextPutAll:'--'.
(tmp isNil)
    ifTrue:[aStream nextPut:$|]
    ifFalse:[aStream nextPut:$>].
[tmp notNil]
    whileTrue:[tmp printOn:aStream.
                      tmp:=tmp next].!
 
size
    ^size!

start

pos:=root.! !

List subclass: #DoubleList
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: '' !


!DoubleList class methods ! !



!DoubleList methods !
   
insert: anObject

|node|

node:=DoubleNode new.
node data: anObject.
self insertNode: node.!
  
insertNode: aDoubleNode

aDoubleNode prev: last.
super insertNode:aDoubleNode.! !
