
Object subclass: #Node
  instanceVariableNames: 
    'data next '
  classVariableNames: ''
  poolDictionaries: '' !


!Node class methods !

data: anObject
    "constructs the object and initializes it"
^self new data: anObject!
   
data: anObject next: aNode

    ^self new data: anObject;
                        next: aNode.! !



!Node methods !
 
data
    ^data.!
   
data: anObject
    data:=anObject.!

next
        "returns next node"
    ^next!
   
next: aNode
        "changes pointer to next"
   next:=aNode.!

printOn: aStream
    aStream nextPut: $[.
    data printOn: aStream.
    aStream nextPutAll: ']-'.
    (next isNil)
        ifTrue: [aStream nextPut:$|]
        ifFalse: [aStream nextPut:$>].! !

Node subclass: #DoubleNode
  instanceVariableNames: 
    'prev '
  classVariableNames: ''
  poolDictionaries: ''    !


!DoubleNode class methods ! !



!DoubleNode methods !
   
prev
    ^prev!

prev: aNode
        "changes pointer to prev"
   prev:=aNode.!

printOn: aStream

    (prev isNil)
        ifTrue:[aStream nextPut: $|]
        ifFalse:[aStream nextPut: $<].
    aStream nextPut: $-.
    super printOn: aStream.! !
